/**
 * What the kobold did during the trip from the forest to Varanar.
 */
function ForestToVaranarShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    this.riverStripped = false; // Whether the kobold stripped before dipping in the river.
    this.riverEvaded = false; // Whether the kobold evaded the bandits when dipping in the river.
    this.riverKnockedOut = false; // Whether the kobold was knocked out by the bandits when dipping in the river.
    this.riverMoneyTaken = false; // Whether the kobold got its money taken by the bandits when dipping in the river.
    this.riverGoliathKilled = false; // Whether or not the kobold killed Goliath in the river.

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A Shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        var defaults = new AfternoonThreeShared();
        if (!shared) {
            that.load(defaults);
            return;
        }
        for (var key in that) {
            if (typeof that[key] === "function") {
                continue;
            }
            that[key] = shared[key] || defaults[key];
        }
        for (var key in shared) {
            if (that[key] || !shared[key]) { // Already processed or don't need to process.
                continue;
            }
            that[key] = shared[key];
        }
    };
}