/**
 * The SmallMirror class represents a small mirror the kobold can buy.
 */
function SmokingPipe() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Pipe";
    var itemDescription = "A wood-carved container for smoking various herbs, from lavendar to expensive tobacco.";
    var baseValue = 30;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.SMOKINGPIPE;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.MISC;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var toReturn = caps ? itemName : itemName.toLowerCase();
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 230px;";
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {Misc-stripped} misc A Misc object, stripped of private members and all functions.
     */
    this.load = function (misc) {

    };
}
