/**
 * Farmer's Maid Enslavement Ending.
 */
function FarmerMaid() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "FarmerMaid";
    var sceneName = "Farmer's Maid";
    var sceneSubfolder = "Enslavement/DayTwo";
    var ctrl = new FarmerMaidController(sceneId, this);
    var arrival = new FarmerMaidArrival(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets all the required global variables such as scene id, scene name,
     * scene stack and theme.
     */
    function setGlobals() {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
    }

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += global.parser.parse(`[t]Enslavement[/t]`);
        tab += global.parser.parse(`[st]Farmer's maid[/st]`);
        tab += arrival.build();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;
    this.subfolder = sceneSubfolder;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        setGlobals();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        arrival.registerListeners();
        ctrl.autosave();
    };

    /**
     * Resets the scene to the starting point.
     */
    this.reset = function () {
        global.kobold.history.set(id, {});
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new FarmerMaid();
    global.sceneLoader.registerScene(scene.id, scene);
});
