/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarConfront(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.CONFRONT;
    var reqController = ctrl.toofar;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Juliet might be [b]dead[/b] by the time you return here with Romeo in tow.
                            You've been ignoring the events playing out in front of you for over a year now.
                            But you can't sit by idly and watch her get beaten to death.
                            You have to act.
                            You have to [b]intervene[/b].
                            Maybe, a stern talking-to might save the day.
                            After all, he stopped harassing you when you told him to go away.
                        [/p]
                        [p]
                            You approach Falco from the side, and expertly catch one of his fists before it manages to impact with his mother's nose.
                            The bird is startled, only barely managing to refrain from punching [b]you[/b] out of fright.
                            "[color=yellow]Slave?
                            Let go of my hand.
                            What the [b]hell[/b] do you want?
                            Can't you see I'm in the middle of something?![/color]"
                        [/p]
                        [p]
                            While intimidated by his lack of restraint, you muster all of the courage you can,
                            and tell the kid that he [b]shouldn't[/b] beat his own mother.
                            She gave birth to him, and for all either of you know, she could very well be pregnant with his child!
                            You said nothing for all these months that he fucked around throughout the entire house,
                            and you kept quiet when sex turned to abuse,
                            but you can't watch him beat her like this.
                        [/p]
                        [p]
                            He needs to get a grip on himself.
                            He's starting to [i]lose it[/i].
                            What happened to the boy that was [i]anxious[/i] to touch you,
                            and immediately stopped when you told him to?
                            The eagle that [b]made love[/b] to his mother instead of beating her senseless?
                            Why is he so [b]angry[/b] and [b]upset[/b] all the time?
                            What changed since you arrived that caused him to grow so [b]violent[/b]?
                        [/p]
                        [p]
                            No answer.
                            The bird stares at you, his hateful expression seemingly faltering.
                            He looks to be growing [i]emotional[/i].
                            You think you're slowly starting to get to him.
                            You continue working on him.
                        [/p]
                        [p]
                            Things can't go on like this.
                            Look at Juliet.
                            Her eyes are so swollen, she can barely [b]see[/b]!
                            How is she supposed to witness her son growing up like this?
                            And her nose.
                            The avian broke her nose.
                            How is she supposed to [b]smell[/b] his [i]lustful loins[/i] through all of that blood?
                            Had he even considered that?
                        [/p]
                        [p]
                            He hadn't.
                            He was just working out his [b]frustration[/b] through violence.
                            And you understand.
                            Life sucks sometimes, and we all want to punch things every now and again.
                            But killing Juliet isn't going to make him any happier.
                            Surely, even through his blind rage, he can see that, right?
                        [/p]
                        [p]
                            You think you're really getting through to him.
                            One more push, and then you're certain he'll relent and give up his violent ways in favor of a healthy relationship with his mother.
                            As far as fucking daily can be considered healthy, that is.
                            Oh well, one problem at a time.
                        [/p]
                        [p]
                            You step in between the avian and his mother.
                            You've known him for over a year now.
                            And while you aren't the [i]best[/i] of friends,
                            you never once told his father about what he was doing to Juliet.
                            You don't really [i]want[/i] to ask for something in return, but he's left you with no choice.
                            You want him to stop hitting the woman of the house.
                            He can keep fucking her as far as you're concerned,
                            but he needs to stop the violent stuff.
                        [/p]
                        [p]
                            If he's really [b]that[/b] frustrated,
                            if he truly [b]must[/b] punch something to feel good about himself, well then.
                            You're right here.
                            He can hit [b]you[/b], if he has to.
                        [/p]
                        [p]
                            Falco's beak trembles.
                            He looks like he's about to [b]cry[/b].
                            But then, interrupting your [i]emotional moment[/i],
                            comes the bird's fist, barreling towards your gut.
                        [/p]
                        [p]
                            The eagle crudely [b]socks[/b] you in the gut,
                            before knocking you to the ground with a swift punch to your temple.
                            You scream out in pain, fearfully curling up into a ball on the floor.
                            "[color=yellow]Fine, you stupid lizard.
                            Guess I'll have to beat [b]you[/b] up instead, from now on.[/color]"
                            N-no!
                            That's not what you meant!
                            The avian crudely spits on your downed frame,
                            and delivers a kick to your back.
                            You don't think he's interested in hearing what you were [i]trying[/i] to accomplish here.
                        [/p]
                        [p]
                            While the injured Juliet crawls out of the room,
                            her son begins to [b]wallop[/b] on you, unleashing a [b]barrage[/b] of kicks and punches and scratches and scrapes.
                            Halfway through the brutal beatdown, an exceptionally hard [b]stomp[/b] to your forehead knocks you unconscious.
                            When you awaken, your entire body hurts.
                            You have bruises [b]everywhere[/b].
                            You can barely [b]stand[/b], let alone [b]walk[/b].
                            You limp over towards your basket, and fall asleep.
                            Your new life, as Falco's stress relief, has begun.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Punching bag end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
