/**
 * The bandit section of the Forest scene.
 * @param {ForestController} controller The forest controller.
 */
function ForestBandit(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var arrival = new ForestBanditArrival(ctrl);
    
    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    
    // PUBLIC MEMBERS \\        this.public = "test";

    // The id of this segment.
    this.id = "forestBandit";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Builds and returns this part.
     * @param {boolean} invisible If true, will build this part invisible.
     */
    this.build = function(invisible) {
        if (!ctrl.bandit.hasSource()) {
            return "";
        }
        var src = ctrl.bandit.getSource();
        var bandit = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if(src === ForestBanditSourceEnum.HOME) {
            bandit += `<div class="subtitle">Investigation</div>`;
        } else {
            bandit += `<div class="subtitle">Safe exploration</div>`;
        }
        bandit += arrival.build();
        bandit += `</div>`;
        return bandit;
    };
    
    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function() {
        if (!ctrl.bandit.hasSource()) {
            return;
        }
        arrival.registerListeners();
    };
}

/**
 * Sources for the bandit encounter.
 */
var ForestBanditSourceEnum = {
    WOODS: 1,
    HOME: 2
};
