/**
 * Accept part of the forest bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var enjoyId = "banditAcceptEnjoyButton";
    var hateId = "banditAcceptHateButton";

    var toSex = new ForestBanditAcceptSex(ctrl);

    var didRock;
    var gender;
    var dick;
    var pants;
    var underwear;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You decide not to struggle against the kobolds' grasp, instead staying still as their leader's hand finds its way atop your chest.
                        `;

        if (gender === GenderEnum.MALE) {
            toReturn += `   He runs his palm along your smooth, scaled torso, studying your face as if to gauge your reaction.`;
        } else {
            toReturn += `   He roughly grabs one of your breasts, groping it whilst studying your face as if to gauge your reaction.`;
        }

        toReturn += `       "<span class="bold brightred">Meek little bitch.</span>" the leader comments, after about a solid minute of the treatment.
                            A wide, ominous grin spreads across the kobold's face.
                            He finally lets go of your jaw.
                            "<span class="bold brightred">We're going to have a lot of [i]fun[/i] with you.</span>"
                        [/p]
                        [p]
                            With a simple nod from the boss, his underlings force you to your knees.
                            Your face is pushed forwards, directly into his groin, your snout ending up rubbing against his bare scales, 
                            his member resting against the side of your muzzle, the tip of it pressing into your cheek.
                        [/p]
                        [p]
                            While up until now, your mind was racing to come up with a new plan to escape the kobolds' clutches still,
                            the scent of cock slowly permeating your nostrils makes you realize that there [i]is[/i] no escape.
                            They [b]are[/b] going to have their way with you, and there's nothing left you can do to stop them.
                            You could, however, make this easier on yourself by [i]playing along[/i].
                            Heck, you might even end up enjoying this entire ordeal.
                        [/p]`;
        return  global.parser.parse(toReturn);
    }

    /**
     * Initializes all private variables.
     */
    function initVars() {
        didRock = (ctrl.bandit.getArrivalChoice() === ForestBanditArrivalChoiceEnum.ROCK);
        gender = ctrl.bandit.intervene.replaceGender();
        dick = ctrl.bandit.intervene.replaceDick();
        pants = ctrl.bandit.intervene.replacePants();
        underwear = ctrl.bandit.intervene.replaceUnderwear();
    }

    /**
     * Builds and returns the enjoy choice button.
     */
    function buildEnjoyChoice() {
        var disabled = ctrl.bandit.intervene.hasMadeAcceptChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.intervene.getAcceptChoice() == ForestBanditAcceptChoice.ENJOY;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${enjoyId}" ${disabled}>Enjoy it</button>`;

        var tooltip = `You might as well enjoy yourself and pleasure the bandits to the best of your abilities.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the hate choice button.
     */
    function buildHateChoice() {
        var disabled = ctrl.bandit.intervene.hasMadeAcceptChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.intervene.getAcceptChoice() == ForestBanditAcceptChoice.HATE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${hateId}" ${disabled}>Hate it</button>`;

        var tooltip = `You hate what they're doing to you. Lie there and take it. Hope they'll be done soon.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildEnjoyChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildHateChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables both buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + enjoyId), $("#" + hateId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the enjoy button.
     */
    function registerEnjoyListener() {
        $("#" + enjoyId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.intervene.makeAcceptChoice(ForestBanditAcceptChoice.ENJOY);
            loadNextPart(toSex);
        });
    }

    /**
     * Adds a listener to the hate button.
     */
    function registerHateListener() {
        $("#" + hateId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.intervene.makeAcceptChoice(ForestBanditAcceptChoice.HATE);
            loadNextPart(toSex);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditReplaceAccept";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.bandit.intervene.getReplaceChoice() !== ForestBanditReplaceChoice.ACCEPT) {
            return "";
        }
        initVars();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        // Build children here.
        part += toSex.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.bandit.intervene.getReplaceChoice() !== ForestBanditReplaceChoice.ACCEPT) {
            return;
        }

        toSex.registerListeners();

        if (ctrl.bandit.intervene.hasMadeAcceptChoice()) {
            return;
        }

        registerEnjoyListener();
        registerHateListener();
    };
}

var ForestBanditAcceptChoice = {
    ENJOY: 1,
    HATE: 2
};
