/**
 * End section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorFreeAcceptLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;
    var changeController = ctrl.killFreeAcceptLeave;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var arms = global.kobold.history.shared.varanar.dayThree.afternoon.parlorArmMassage;
        var back = global.kobold.history.shared.varanar.dayThree.afternoon.parlorBackMassage;
        var alreadyDislocated = global.kobold.history.shared.well.basiliskFingerDislocated;
        var toReturn = `[p]
                            You wake up not too long later, still on the floor.
                            Red is gone.
                            The other two are gone.
                            Even Tychus' corpse is missing.
                            Your ${arms ? `arm` : back ? `back` : `foot`} hurts.
                            [b]Everything[/b] hurts.
                        [/p]`;

        if (arms) {
            toReturn += `[p]
                            Your arm is still fucked up.
                            Dislocated,
                            bending the wrong way${alreadyDislocated ? `, like your finger did in the well` : ``}.
                            There's only one way to fix this.
                            And you aren't looking forward to it.
                        [/p]
                        [p]
                            You pick up a convenient, small piece of wood laying about, and place it in your muzzle, to bite down on.
                            You'll need it.
                            This is going to hurt.
                            With your one functioning arm, you grab onto your limp-hanging wrist.
                            Taking a deep breath, you [b]pull[/b].
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Once again, you [b]scream[/b] out in pain,
                            completely reduced to tears as your bones [b]painfully[/b] re-arrange themselves back into position.
                            Your teeth dig into the stick in your mouth, you wildly [b]bang[/b] your one functioning hand against the wooden floor,
                            you kick and flail your legs about, and you cry your eyeballs out.
                            It's [b]too much[/b] pain!
                        [/p]
                        [p]
                            Your shallow, ragged breathing slowly turns into deep, soothing breaths as the massive spike of tormenting trauma begins to die down,
                            leaving you a sobbing green mess of scales and tears.
                            You just wanted to help them.
                            And this is how they repaid you.
                        [/p]
                        [p]
                            You spit out the piece of wood, and through your teary eyes,
                            you are glad to see that you have regained full motion over your relocated arm.
                            Moving it still hurts, but you're certain that will improve over time.
                            Maybe you'd have been better off [b]not[/b] trying to be a hero, but damnit, you feel like you did the right thing.
                            You'd do it again, if given a chance, apart from maybe trusting Red.
                        [/p]
                        [p]
                            You need to get out of here.
                            It's time to leave.
                            You don't care where Tychus went.
                            You don't care where the kobolds went.
                            You don't [b]ever[/b] want to see that red one again.
                            And you don't [b]ever[/b] want to experience [b]any[/b] kind of pain like this again.
                        [/p]
                        [p]
                            You scramble to your feet,
                            and waddle out the door, never to return to this [b]damnable[/b] place.
                            Still clutching your arm, you walk off the pain,
                            headed for the mercantile district.
                        [/p]
                        [p]
                            Arriving at your destination, the sun is slowly starting to set.
                            The lower it gets, the more distant your agony seems.
                            The afternoon is turning into a dark and cold winter evening.
                            It's time to figure out where you're going to sleep.
                            Maybe tomorrow, you can find some more [b]grateful[/b] kobolds to [i]liberate[/i].
                        [/p]`;
        } else if (back) {
            toReturn += `[p]
                            Your back is still fucked up.
                            A vertebra is dislocated,
                            jutting out from the rest of your spine${alreadyDislocated ? `, like your finger was in the well, but worse` : ``}.
                            There's only one way to fix this.
                            And you aren't looking forward to it.
                        [/p]
                        [p]
                            You pick up a convenient, small piece of wood laying about, and place it in your muzzle, to bite down on.
                            You'll need it.
                            This is going to hurt.
                            With one arm, you reach for your back, and place your palm atop the protruding bit of bone.
                            Taking a deep breath, you [b]ram[/b] it back into place.
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Once again, you [b]scream[/b] out in pain,
                            completely reduced to tears as your spine [b]painfully[/b] re-arranges itself back into proper position.
                            Your teeth dig into the stick in your mouth, you wildly [b]bang[/b] your balled-up hands against the wooden floor,
                            and you cry your eyeballs out.
                            It's [b]too much[/b] pain!
                        [/p]
                        [p]
                            Your shallow, ragged breathing slowly turns into deep, soothing breaths as the massive spike of tormenting trauma begins to die down,
                            leaving you a sobbing green mess of scales and tears.
                            You just wanted to help them.
                            And this is how they repaid you.
                        [/p]
                        [p]
                            You spit out the piece of wood, and through your teary eyes,
                            you are glad to see that you have regained full motion over your legs.
                            Moving them is still a bit iffy, but you're certain that will improve over time.
                            Maybe you'd have been better off [b]not[/b] trying to be a hero, but damnit, you feel like you did the right thing.
                            You'd do it again, if given a chance, apart from maybe trusting Red.
                        [/p]
                        [p]
                            You need to get out of here.
                            It's time to leave.
                            You don't care where Tychus went.
                            You don't care where the kobolds went.
                            You don't [b]ever[/b] want to see that red one again.
                            And you don't [b]ever[/b] want to experience [b]any[/b] kind of pain like this again.
                        [/p]
                        [p]
                            You climb to your unsteady feet,
                            and waddle out the door, never to return to this [b]damnable[/b] place.
                            Using one of your arms to keep your back straightened, you walk off the pain,
                            headed for the mercantile district.
                        [/p]
                        [p]
                            Arriving at your destination, the sun is slowly starting to set.
                            The lower it gets, the more distant your agony seems.
                            The afternoon is turning into a dark and cold winter evening.
                            It's time to figure out where you're going to sleep.
                            Maybe tomorrow, you can find some more [b]grateful[/b] kobolds to [i]liberate[/i].
                        [/p]`;
        } else {
            toReturn += `[p]
                            Your foot is still fucked up.
                            Dislocated,
                            twisted the wrong way around${alreadyDislocated ? `, like your finger was in the well` : ``}.
                            There's only one way to fix this.
                            And you aren't looking forward to it.
                        [/p]
                        [p]
                            You pick up a convenient, small piece of wood laying about, and place it in your muzzle, to bite down on.
                            You'll need it.
                            This is going to hurt.
                            With both of your hands, your reach for your limp foot, firmly grasping onto it.
                            Taking a deep breath, you [b]twist[/b] it back into place.
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Once again, you [b]scream[/b] out in pain,
                            completely reduced to tears as your bones [b]painfully[/b] re-arrange themselves back into position.
                            Your teeth dig into the stick in your mouth, you wildly [b]bang[/b] your balled-up hands against the wooden floor,
                            you kick and flail your one good leg about, and you cry your eyeballs out.
                            It's [b]too much[/b] pain!
                        [/p]
                        [p]
                            Your shallow, ragged breathing slowly turns into deep, soothing breaths as the massive spike of tormenting trauma begins to die down,
                            leaving you a sobbing green mess of scales and tears.
                            You just wanted to help them.
                            And this is how they repaid you.
                        [/p]
                        [p]
                            You spit out the piece of wood, and through your teary eyes,
                            you are glad to see that you have regained full motion over your foot.
                            Wriggling your toes about still hurts, but you're certain that will improve over time.
                            Maybe you'd have been better off [b]not[/b] trying to be a hero, but damnit, you feel like you did the right thing.
                            You'd do it again, if given a chance, apart from maybe trusting Red.
                        [/p]
                        [p]
                            You need to get out of here.
                            It's time to leave.
                            You don't care where Tychus went.
                            You don't care where the kobolds went.
                            You don't [b]ever[/b] want to see that red one again.
                            And you don't [b]ever[/b] want to experience [b]any[/b] kind of pain like this again.
                        [/p]
                        [p]
                            You climb to your unsteady feet, leaning most of your weight on the foot that [i]wasn't[/i] dislocated,
                            and you limp out the door, never to return to this [b]damnable[/b] place.
                            As you walk off the pain,
                            headed for the mercantile district,
                            your gait gradually improves,
                            as you begin to use your hurting foot more and more.
                        [/p]
                        [p]
                            Arriving at your destination, the sun is slowly starting to set.
                            The lower it gets, the more distant your agony seems.
                            The afternoon is turning into a dark and cold winter evening.
                            It's time to figure out where you're going to sleep.
                            Maybe tomorrow, you can find some more [b]grateful[/b] kobolds to [i]liberate[/i].
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.applyTheme("varanar_generic");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
