/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyMeanDoNot(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyMeanSexChoice.DONOT;
    var reqController = ctrl.meanSex;
    var changeController = ctrl.meanDoNot;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var naked = ctrl.misc.nude();
        var dickt4 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt4;
        var dickt3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt3;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1 || t2) {
            toReturn += `
                        [p]
                            Fuck no.
                            You don't owe her anything.
                            ${dickt4 ? `She got off to this every bit as much as you did.` : `She hasn't [b]earned[/b] her locket.`}
                            Maybe if the woman was a tad more [b]enthusiastic[/b] about this whole ordeal, you'd be a bit more inclined to return what is hers.
                            When you slapped her ass, she didn't even [b]admit[/b] that she liked it.
                            Dragons are supposed to be [b]amazing[/b] prostitutes.
                            She was [b]average[/b], at best.
                            No, she doesn't [b]deserve[/b] her locket.
                        [/p]
                        [p]
                            You're a thief.
                            Stealing is what you do.
                            The heirloom'll undoubtedly fetch a nice price.
                            You quite simply [b]need[/b] the gold you'll get from selling it, far more than she needs her memorabilia.
                            ${!naked ? `You quickly collect your gear, and redress.` : ``}
                            Moving towards the door, the dragoness stops you.
                            "[color=cyan]Wait! What about my locket?![/color]"
                            Turning your head, you shoot a wicked smile her way.
                            Let this be a lesson.
                            Maybe next time, she'll ask for payment [b]before[/b] offering her [b]whore ass[/b] to a random kobold she met [b]five minutes[/b] ago.
                            That said, you prompty exit the hovel,
                            leaving the shocked woman lying ${dickt3 ? `in a puddle of your spunk` : `on the filthy mattress`}.
                        [/p]
                        [p]
                            Outside and out of view, you catch some relatively fresh air.
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least another bitchy dragoness to trick into having sex with you.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Nah.
                            You don't owe her [b]anything[/b].
                            Sure, she was a good fuck, and she mostly [i]behaved[/i],
                            but you just don't think that single romp was worth as much as the trinket is.
                            Besides, she enjoyed this every bit as much as you did.
                            You're certain she has enough money to buy a [b]dozen[/b] lockets exactly like this one.
                        [/p]
                        [p]
                            You're a thief.
                            Stealing is what you do.
                            The heirloom'll undoubtedly fetch a nice price.
                            You quite simply [b]need[/b] the gold you'll get from selling it, far more than she needs her memorabilia.
                            ${!naked ? `You quickly collect your gear, and redress.` : ``}
                            As you move towards the door, the confused dragoness speaks up.
                            "[color=cyan]Where are you going? I thought you said the locket was in here?[/color]"
                            Feeling slightly guilty, you can't muster the courage to respond to her question.
                            Silently, you stride out the door, and exit the alleyway,
                            leaving the perplexed woman lying ${dickt3 ? `in a puddle of your spunk` : `on the filthy mattress`}.
                        [/p]
                        [p]
                            Outside and out of view, you catch some relatively fresh air.
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least some way to ease your aching conscience.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}


