/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyKindReturn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyKindChoice.RETURN;
    var reqController = ctrl.kind;
    var changeController = ctrl.kindReturn;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyLocket = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You're fairly certain that was the first time the dragoness has [b]ever[/b] said that word to [b]anyone[/b],
                            apart from perhaps her own family.
                            In a weird way, you guess this sort of counts as taking some eldritch form of [i]virginity[/i] from her?
                            Please-ginity?
                            You stop that train of thought before it gets any more [i]awkward[/i].
                        [/p]
                        [p]
                            Either way, it's pretty [i]sad[/i] that she struggled so much to simply be nice, for a change.
                            You've half a mind to continue to [i]educate[/i] her on what it means to be [b]polite[/b],
                            but a deal's a deal.
                            If you stooped down into dishonesty,
                            apart from the small lies you told to get her to follow you into the alley,
                            you'd be no better than she is.
                            Because she asked so nicely, you step into the abandoned hovel, and disappear behind a metal wall.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant.
                            "[color=cyan]About time! Now hand it over, you-[/color]" As she reaches over, you snatch your hand back.
                            It's obvious she hasn't learned her lesson.
                            Looks like you'll be tormenting her a bit more after all.
                            She hasn't said the [b]other[/b] magic words yet.
                        [/p]
                        [p]
                            The chubby dragoness lifts an eyebrow.
                            "[color=cyan]The [i]other[/i] magic words?[/color]"
                            Suddenly, her face sours as she understands what you're asking of her.
                            "[color=cyan]You little [b]ghoul[/b].[/color]" she practically spits out.
                            At least you didn't have to spell it out for her this time around.
                            The woman looks away.
                            You can see her lips move.
                            She mutters something barely audible.
                        [/p]
                        [p]
                            What was that, you ask?
                            "[color=cyan][b]I said THANK YOU![/b][/color]" she lashes out,
                            almost loud enough to draw attention from kobolds outside of the alleyway.
                            Before you can object, the lady [b]grabs[/b] the locket from your hand, and quickly puts it around her neck, where it belongs.
                            "[color=cyan]Uppity little [b]mongrel[/b].[/color]" she murmurs to herself,
                            huffing angrily before turning her back to you, and promptly walking away.
                        [/p]
                        [p]
                            That sure was [i]something[/i].
                            You might have pushed her a little [i]too hard[/i] near the end there,
                            but you hope your lesson sticks.
                            It probably won't -- at all -- but a kobold can dream, right?
                            Oh well, at least you won't have to stand her constant insults anymore.
                            Seeing her almost burst into tears made this entire ordeal worthwhile.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least someone who'll treat you with a bit more [b]dignity[/b] and [b]respect[/b] than the bitchy dragoness.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            You're fairly certain that was the first time the dragoness has [b]ever[/b] said that word to [b]anyone[/b],
                            apart from perhaps her own family.
                            In a weird way, you guess this sort of counts as taking some eldritch form of [i]virginity[/i] from her?
                            Please-ginity?
                            You stop that train of thought before it gets any more [i]awkward[/i].
                        [/p]
                        [p]
                            You made a deal with her, and while it took her a bit to get over her own [b]bitchiness[/b],
                            she [b]did[/b] eventually do what was asked of her.
                            Now it's your turn.
                            You step into the hovel, and disappear behind a metal wall.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant.
                            She even manages a bit of a smile, for a moment.
                            "[color=cyan]Good. Uh...good work.[/color]"
                            Your [i]lesson[/i] seems to have been somewhat effective.
                            She corrected herself to be more polite!
                            Probably only because you still hold her locket,
                            and she fears you'll [b]make[/b] her be nice if she's not,
                            but it's better than her being rude [b]all[/b] the time.
                            A moderate success.
                            You'll take it.
                        [/p]
                        [p]
                            Pleased with the results of your crash-course in pleasantries,
                            you hand the dragoness her necklace.
                            Once more, a small smile creeps on her face, only to vanish mere moments after.
                            She quickly puts the pendant back around her neck, where it belongs.
                        [/p]
                        [p]
                            "[color=cyan]T-thank you.
                            Now if you'll excuse me?[/color]"
                            Wow, you expected her to go right back to being a [b]bitch[/b] after you'd given her what she wanted.
                            Looks like you've made a lasting impression.
                            Too bad you don't get to enjoy the lady's presence for much longer.
                            She turns her back to you, and promptly vacates the alleyway.
                        [/p]
                        [p]
                            You're somewhat [i]proud[/i] of your actions.
                            You taught a snobby dragoness that a few kind words uttered to her [i]servants[/i] every now and again won't [b]kill[/b] her.
                            It remains to be seen whether or not this lesson will [b]stick[/b],
                            but even if only for a single day, you've undoubtedly made the world a better place.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another noble to [i]educate[/i].
                        [/p]`;
        } else {
            global.kobold.history.shared.varanar.dayThree.afternoon.rubyName = true;
            toReturn += `
                        [p]
                            Praised by a princess.
                            You thought you'd never see the day.
                            Is this how knights feel?
                            It feels [b]incredible[/b]!
                            Of course you'll fetch her locket.
                            Straight away!
                            You step into the hovel, and disappear behind a metal wall.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant.
                            A big, broad smile forms on her face.
                            "[color=cyan]Yes!
                            My locket!
                            You found it!
                            Thank you, oh thank you![/color]"
                            Overjoyous, the lady picks you up off the ground, and wraps her arms around you, pulling you in close for royal [b]hug[/b],
                            tightly pressing you against her warm, chubby body.
                        [/p]
                        [p]
                            For a few moments, you feel like you're in [b]heaven[/b].
                            Pressed tightly against the lady's bosom, her surprisingly strong arms squeezing you affectionately.
                            You are overfilled with joy and happiness.
                            Is this what pure, unbridled affection feels like?
                            You return the hug.
                            You [b]never[/b] want to let go.
                            But alas, all too soon, she lets go of you, putting you back down onto the cold street.
                            Somewhere mid-hug she must have taken the pendant from you.
                            She puts it around her neck, where it belongs.
                        [/p]
                        [p]
                            The beaming smile on the dragoness' face suddenly disappears, as though she realize who and [i]where[/i] she is.
                            She suspiciously looks for anyone who might be [i]spying[/i] on the two of you.
                            Once she's positive that nobody's around, she clears her throat and straightens her muddy dress.
                            It is as though her noble attitude has returned to her.
                        [/p]
                        [p]
                            "[color=cyan]You have my gratitude for this, little one.
                            My name is [b]Ruby[/b].
                            Should we cross paths again, under more favorable circumstances,
                            then perhaps I will see fit to return the favor.
                            For now, I must depart.
                            This place is [i]unbefitting[/i] of a lady.[/color]"
                            You understand.
                            If you were in her position, you wouldn't want to be seen around here either.
                            You bid the dragoness farewell, and stare after her as she turns around and walks away, her head held high.
                        [/p]
                        [p]
                            That was [b]incredible[/b].
                            Do knights get rewarded like this all the time?
                            If so, you [b]really[/b] want to be one.
                            And by helping out a princess in need, you feel like you've taken a step on the right path.
                            If you can keep this up, you'll be a kobold knight in no time!
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another chance to showcase your chivalry.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.imageBackground.hide();
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }


        if (global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3) {
            global.ui.imageBackground.show("scenes/Varanar/DayThree/AfternoonThree/ruby/img/Dragon_hug.png");
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
