/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyKiss(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyBargainChoice.KISS;
    var reqController = ctrl.bargain;
    var subController = ctrl.kiss;
    var changeController = ctrl.kiss;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyKissReturn(ctrl);
    var secondNext = new AfternoonThreeRubyKissMore(ctrl);

    var firstChoice = AfternoonThreeRubyKissChoice.RETURN;
    var secondChoice = AfternoonThreeRubyKissChoice.MORE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyKiss = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You kind of [i]regret[/i] not having handed the dragoness the locket straight away.
                            That walk through the streets was [b]humiliating[/b].
                            Kobolds were staring at you.
                            And the worst thing about it is that the lady is entirely [b]oblivious[/b] to how much she was pissing everyone off.
                            You turn to face the lady, looking up at her haughty eyes and snarling lips.
                            Even through all of that anger and superiority, she's a beautiful woman.
                        [/p]
                        [p]
                            "[color=cyan]Well? It's [b]rude[/b] to keep a lady waiting. Get on with it already![/color]"
                            But you won't.
                            You tell her that you're [b]not[/b] her servant.
                            That you didn't lead her here,
                            despite her constant [b]yammering[/b] and [b]complaining[/b],
                            without expecting a reward.
                            Her eyes flare up with a mixture of confusion and fear.
                            Nothing too big.
                            All you want is the traditional boon that maidens always bestow upon their [b]rescuers[/b].
                        [/p]
                        [p]
                            "[color=cyan]What are you on about?! What is this [i]boon[/i]?![/color]"
                            You tilt your head upwards, and tap the front of your muzzle with one of your fingers.
                            Why, it's a kiss, of course.
                            Her face turns to disgust.
                            "[color=cyan]You think I'm going to [b]kiss[/b] a [b]lowlife[/b] like [b]you[/b]?!
                            The thought alone makes me [b]sick[/b]![/color]"
                        [/p]
                        [p]
                            The dragoness is clearly overreacting, but her words still cut deeper than any knife or blade ever could.
                            Does she [b]really[/b] think [b]that[/b] low of you?
                            Of [b]all[/b] kobolds, perhaps?
                            You suddenly feel grossly inadequate.
                            Like you've spent your entire life not realizing what a [b]pathetic worm[/b] you are compared to the rest of the world.
                        [/p]
                        [p]
                            But the feeling quickly passes, replaced instead by anger of your own.
                            You hold all the cards here, and not her.
                            She has [b]no[/b] right to insult you like that.
                            You glare up at her, and stand your ground.
                            If she wants her locket, then you want a kiss.
                            And if she doesn't like that, then she can go get it [b]herself[/b].
                        [/p]
                        [p]
                            The two of you stare eachother down in silence for about half a minute.
                            Eventually, her the stern grimace on her face slowly fades, as the dragoness resigns herself to her fate.
                            Her entire body shudders, tears welling up in her eyes.
                            "[color=cyan][b]Fine[/b].
                            F-fine...
                            Oh, gods.
                            Go get it first.
                            I need to prepare.[/color]"
                        [/p]
                        [p]
                            You can tell that she's struggling to even say those words.
                            While you [i]were[/i] hoping for payment in advance, you can settle for those terms.
                            You give a broad, mischievous smirk, telling her you'll be waiting once you get back.
                            She swallows deeply, out of fear, disgust and anxiety.
                            You leave her be, and step into the hovel.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant,
                            but her visage sours once more as she remembers what she owes you in return.
                            "[color=cyan]Ugh... L-let's just get this over with. Come here.[/color]"
                        [/p]
                        [p]
                            You walk over to the lady, holding your hands behind your back to keep the locket away from her.
                            Arriving in front of her, you stand on your tippy-toes, stretching upwards as far as you can.
                            She still has to lean down in order to reach you,
                            but before she does so, the woman first looks around to make sure you're [b]completely[/b] alone.
                            Lowering her head to your level, her face scrunches up in disgust as she gets a whiff of your breath.
                            She backs away slightly, almost gagging.
                            "[color=cyan]D-do I [b]really[/b] have to do this?[/color]"
                        [/p]
                        [p]
                            Of course she does.
                            That was the deal.
                            You stubbornly stay right there, your eyes denoting your seriousness.
                            She lets out a dissatisfied groan, exhales and inhales deeply, and then leans in again, closer this time.
                            Her breath feels warm on your snout.
                            It, admittedly, smells better than yours does.
                            Finally, after a lot of doubting, the dragoness breaks through her own inhibitions.
                            She presses her lips against yours, for a small, quick, reluctant kiss.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            The dragoness is kind of [b]mean[/b].
                            While somewhat [i]tolerable[/i] when speaking to you,
                            it is [b]very[/b] clear that you are the [b]exception[/b], and not the rule.
                            She constantly berates and belittles kobolds as a whole.
                            And you don't think that's very appropriate, but at the same time, it kind of [b]entices[/b] you.
                            You turn to face the lady, looking up at her haughty eyes and pursed lips.
                            Something about her air of superiority makes her [b]irresistable[/b] to you.
                        [/p]
                        [p]
                            "[color=cyan]Well? It's [b]rude[/b] to keep a lady waiting. Get going.[/color]"
                            You flash a smile at her, trying to seem all happy and eager to serve to placate her a bit.
                            Then, you ask her, as nicely as you can whether you can perhaps get a small token of gratitude in return for your troubles?
                            "[color=cyan]What? Do you want [b]money[/b]?[/color]"
                        [/p]
                        [p]
                            No, no!
                            Not money.
                            You tap the front of your muzzle with one of your fingers.
                            A kiss.
                            That's all you want.
                            Just a peck on the lips.
                            That's not asking for [i]too much[/i], is it?
                            You wouldn't normally ask this, but she's so [b]pretty[/b] and [b]beautiful[/b].
                            You can't help yourself!
                        [/p]
                        [p]
                            "[color=cyan]I...[/color]" The dragoness looks down at you, aghast.
                            "[color=cyan]Y-you dare! You are, uhhh, a [b]servant[/b]! Unworthy of... I, uh...[/color]"
                            For the first time since you've met, she seems to be lost for words.
                            It's like she [b]wants[/b] to be upset at you, but at the same time she's flattered and wants to relent.
                            She attempts to stammer out insults for the better part of a minute,
                            before finally settling down, taking a deep breath and relaxing.
                        [/p]
                        [p]
                            "[color=cyan]F-fine.
                            I will consider your request.
                            But first, you will fetch what is mine.[/color]"
                            While you [i]were[/i] hoping for payment in advance, you can settle for those terms.
                            She was actually kind of [i]cute[/i] when conflicted, but you keep that comment to yourself.
                            Instead, you bravely step into the hovel, to [i]fetch[/i] her pendant.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant,
                            but then she takes another deep breath, calming her excitement.
                            The lady sticks her hand out, expecting you to place the necklace in her open palm.
                            You wordlessly comply, returning what is hers.
                            Now that she has her locket back, you're kind of half-expecting the woman to neglect her side of the deal.
                        [/p]
                        [p]
                            The dragoness dons her locket, after inspecting it for a few moments.
                            Then, she addresses you.
                            "[color=cyan]Chin up. Hold still.[/color]"
                            Short, and straight to the point.
                            You like that.
                            Once more, you do as she tells you.
                            "[color=cyan]Close your eyes.[/color]"
                            Your heart skips a beat.
                            You close your eyes.
                            Is this really happening?
                        [/p]
                        [p]
                            For a few moments, nothing.
                            Then, suddenly, you feel the dragoness' warm, fragrant breath on your snout.
                            Her soft lips press against yours.
                            Joy and happiness flood your mind.
                            A strange warmth spreads throughout your entire body.
                            Butterflies flutter around in your stomach.
                            Is this what love feels like?
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            While she was a little upset at first, the dragoness has been nothing but [b]nice[/b] to you.
                            Asking her for money would be downright [b]rude[/b].
                            No, no.
                            An aspiring knight like yourself needs no monetary compensation.
                            All you want is a little kiss to stroke your ego.
                            But she's so beautiful, you doubt she'd be willing to stoop so low as to kiss, well, [b]you[/b].
                        [/p]
                        [p]
                            You flash the lady a smile, and jokingly asking for the [i]usual[/i] reward that knights get when saving fair maidens.
                            You know, a kiss!
                            Then, you awkwardly laugh your request off, and before she has a chance to answer,
                            you step into the hovel, and conceal yourself behind a metal wall.
                            Stupid, stupid, [b]stupid[/b]!
                            Charismatic as you are, you just made this entire ordeal [b]a lot[/b] more awkward than it should have been.
                            To calm yourself down, you take a look around the abandoned home.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Besides the straw-filled mattress, there isn't much of [i]anything[/i] in the shack.
                            You look around for a bit longer, to give the dragoness the [i]illusion[/i] that you actually had to search for her trinket,
                            and to calm yourself down a little.
                            After a few minutes have passed, you pull the locket from your coin pouch, and with it in hand, you stride out of the hovel.
                        [/p]
                        [p]
                            The dragoness's eyes light up as soon as she sees that you're carrying her pendant.
                            She sticks her hand out, expecting you to place the necklace in her open palm.
                            You wordlessly comply, returning what is hers.
                            You've half a mind to [b]confess[/b], to tell her that you had her locket all along,
                            and that there was no need for you to drag her here.
                        [/p]
                        [p]
                            But suddenly, after donning her necklace once more,
                            you feel her elegant fingers below your muzzle, nudging your visage up to meet her own.
                            Flabbergasted, you stare in awe as she leans down, and slowly presses her soft lips against yours,
                            pulling you into a tender kiss.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Return the locket</button>`;

        var tooltip = global.parser.parse(`She's held up her part of the deal. Time for you to honor yours.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildT2First() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Let her go</button>`;

        var tooltip = global.parser.parse(`She's held up her part of the deal. Let the dragoness leave.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} disabled>Want more</button>`;

        var tooltip = global.parser.parse(`Force the dragoness into a deeper kiss. [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1 ? buildFirstChoice() : buildT2First();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        //part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        //secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        //registerSecondListener();
    };
}

var AfternoonThreeRubyKissChoice = {
    RETURN: 1,
    MORE: 2
};
